



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#的运算符重载</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#的运算符重载</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 23:41:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>运算符重载看起来与标准静态方法声明类似，但它们使用关键字operator和运算符本身，而不是一个方法名：</p>
<p>public static 返回类型 operator +(类型1 变量1,类型2 变量2)</p>
<p>{</p>
<p>//返回类型，类型1，类型2 ，可以相同，也可以全部不同</p>
<p>}</p>
<p>如果使用混合类型的话，需要注意的是，不可以将相同的运算符添加到不同的类进行重载。</p>
<p>还需要注意，操作数的顺序也必须与运算符重载的参数顺序保持一致。</p>
<div>
<pre class="prettyprint linenums"> class AddClass1<br />
    {<br />
        public int val;<br />
        public static AddClass1 operator +(AddClass1 op1,AddClass1 op2)<br />
        {<br />
            AddClass1 returnVal = new AddClass1();<br />
            returnVal.val = op1.val + op2.val;<br />
            return returnVal;<br />
        }

        public static AddClass1 operator ~(AddClass1 op1)<br />
        {<br />
            AddClass1 returnVal = new AddClass1();<br />
            returnVal.val = ~op1.val;//按位取反<br />
            return returnVal;<br />
        }

        public static AddClass3 operator +(AddClass1 op1, AddClass2 op2)<br />
        {<br />
            AddClass3 returnVal = new AddClass3();<br />
            returnVal.val = op1.val + op2.val;<br />
            return returnVal;<br />
        }<br />
    }

    class AddClass2<br />
    {<br />
        public int val;<br />
    }

    class AddClass3<br />
    {<br />
        public int val;<br />
    }

    class Program<br />
    {<br />
        static void Main(string[] args)<br />
        {<br />
            AddClass1 op1 = new AddClass1();<br />
            op1.val = ;<br />
            AddClass2 op2 = new AddClass2();<br />
            op2.val = ;<br />
            AddClass3 op3 = op1 + op2;<br />
            Console.WriteLine("op1+op2 = {0}", op3.val);<br />
            Console.ReadKey();<br />
        }<br />
    }</pre>
</div>
<p>如果重载了true和false运算符，就可以在布尔表达式中直接使用类。例如</p>
<p>ClassA a; if(a){}</p>
<p>以下运算符不能重载，例如+=，=，&amp;&amp;，||</p>
<p>此外&gt;,&lt;必须成对重载 [&gt;=,&lt;=]</p>
<p>此规则也==,!=,但是对于这些==,!=运算符，常常需要重写Object.Equals()和Object.GetHashCode()，因为这两个函数也可以用于比较对象。</p>
<p>重写这些方法。可以确保无论类的用户使用什么技术，都能得到相同的结果。这不太重要，但应增加进来，以保证其完整性。</p>
<p>它需要下述<strong>非静态</strong>重写方法</p>
<div>
<pre class="prettyprint linenums">class AddClass1<br />
    {<br />
        public int val;

        /// &lt;summary&gt;<br />
        /// ==和!=的重载必须成对出现<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="op1"&gt;&lt;/param&gt;<br />
        /// &lt;param name="op2"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public static bool operator ==(AddClass1 op1, AddClass1 op2)<br />
        {<br />
            return (op1.val == op2.val);<br />
        }

        /// &lt;summary&gt;<br />
        /// ==和!=的重载必须成对出现<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="op1"&gt;&lt;/param&gt;<br />
        /// &lt;param name="op2"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public static bool operator !=(AddClass1 op1, AddClass1 op2)<br />
        {<br />
            return !(op1 == op2);<br />
        }

        public override bool Equals(object obj)<br />
        {<br />
            if (obj is AddClass1)<br />
            {<br />
                return val == ((AddClass1)obj).val;<br />
            }<br />
            else<br />
            {<br />
                throw new ArgumentException(string.Format("Can not compare AddClass1 objects with objects of type {0}", obj.GetType().ToString()));<br />
            }<br />
        }

        public override int GetHashCode()<br />
        {<br />
            return val;<br />
        }<br />
    }</pre>
</div>
<p>GetHashCode()可根据其状态，获取对象实例的一个唯一的int值[类似于主键，唯一标示符]</p>
<p>需要注意的是Equals必须使用object参数，否则就变成重载函数而不是重写了。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e02mjq.html">数据库SQL语句练习题</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q234vw9.html">我的 C&plus;&plus; style</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdrprx8.html">word-wrap&colon; break-word&semi; break-word&colon; break-all&semi;区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1or428.html">Java系列笔记&lpar;3&rpar; - Java 内存区域和GC机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/49567oe8.html">July 29th&comma; Week 31st Friday&comma; 2016</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1kjzd9.html">linu流量监控</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdovzy8.html">在线编辑器 &lpar;UBB&comma; FCK&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0ewg4q.html">Qt之命令行编译（nmake）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm54jz9.html">notifyDataSetChanged listview内容没更新的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o2lw49.html">Linux只iptables</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z47ke9.html">JSP基本语法--包含指令&amp;lt&semi;&percnt;&commat;include file&equals;&amp;quot&semi;路径&amp;quot&semi;&percnt;&amp;gt&semi;  &amp;lt&semi;jsp&colon;include page&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/950jjpv8.html">LSTM模型与前向反向传播算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgw3me8.html">MySQL 加锁处理分析-转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd6dx79.html">JAVA基础之序列化与反序列化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zlwv09.html">Django缓存机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mwrnn8.html">Fliptile &lbrack;POJ3279&rsqb; &lbrack;开关问题&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvv2z38.html">面试问烂的 Spring AOP 原理、SpringMVC 过程&lpar;求求你别问了&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy017dq.html">layer&period;js 中弹框显示不全的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w2vprq.html">spring boot&colon; ConfigurationProperties</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyz3nmq.html">网易云音乐mp3外链、真实地址下载方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mndn7rq.html">Poj2420 A Star not a Tree&quest;  模拟退火算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm3ez79.html">JAVA  关于Icon，Image，ImageIcon的简单的对比参考                                                    分类：            Java Game             2014-08-14 17&colon;08    210人阅读    评论&lpar;0&rpar;    收藏</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd4gr48.html">【bzoj1002】&lbrack;FJOI2007&rsqb;轮状病毒</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wx523q.html">&lbrack;百度空间&rsqb; &lbrack;原&rsqb; Empty base class optimization</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjmpkz9.html">《深入浅出JavaScript》</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnl2xd8.html">Docker学习资料</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0eezwq.html">【算法】E&period;W&period;Dijkstra算术表达式求值</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmon609.html">使用tomcat7创建异步servlet</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1d5v38.html">KMP高质量代码实现详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmowm09.html">Eclipse下Python的MySQLdb的安装以及相关问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
